;=======================================================================================================
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
;load "$NCARG_ROOT/lib/ncarg/nclscripts/wrf/WRFUserARW.ncl"
load "./WRFUserARW.ncl"
;=======================================================================================================
begin
;=======================================================================================================
;a = addfile("./wrfout_d01_JAS_ncrcat.nc","r")
c = addfile("../../JAS.20050901_00-20051001_00/wrfout/wrfout_d01_2005-10-01_00:00:00.nc","r")
b = addfile("../../JAS.20050701_00-20050801_00/wrfout/wrfout_d01_2005-07-01_00:00:00.nc","r")
cord = addfile("./coords_d01.nc","r")

;rain = wrf_user_getvar(a,"RAINNC",-1)
rain_b = wrf_user_getvar(b,"RAINNC",0)
rain_bc = wrf_user_getvar(b,"RAINC",0)
rain_c = wrf_user_getvar(c,"RAINNC",0)
rain_cc = wrf_user_getvar(c,"RAINC",0)
printVarSummary(rain_c)
i_rain_b = wrf_user_getvar(b,"I_RAINNC",0)
i_rain_bc = wrf_user_getvar(b,"I_RAINC",0)
i_rain_c = wrf_user_getvar(c,"I_RAINNC",0)
i_rain_cc = wrf_user_getvar(c,"I_RAINC",0)

lon = wrf_user_getvar(cord,"XLONG",0)
lat = wrf_user_getvar(cord,"XLAT",0)


irain_b = i_rain_b*1000.
irain_bc = i_rain_bc*1000.
irain_c = i_rain_c*1000.
irain_cc = i_rain_cc*1000.

;tot_pr = (rain(dims(0)-1,:,:)-rain(0,:,:))+irain
tot_pr = (rain_c+irain_c) - (rain_b+irain_b)
;tot_pr = where(tot_pr.ge.0.1,tot_pr,tot_pr@_FillValue)
tot_pr@description = "Total Grid Scale Precipitation"
tot_pr@units = "mm"
tot_pr@lon2d = lon
tot_pr@lat2d = lat

tot_prc = (rain_cc+irain_cc) - (rain_bc+irain_bc)
tot_prc@description = "Total Cumulus Precipitation"
tot_prc@units = "mm"
tot_prc@lon2d = lon
tot_prc@lat2d = lat

pr = tot_pr + tot_prc
pr@description = "Total Precipitation"
pr@units = "mm"
pr@lon2d = lon
pr@lat2d = lat
;=======================================================================================================
  type = "png"
  type@wkHeight =800
  type@wkWidth = 1000
  wks = gsn_open_wks(type,"d01_rain_total")

  colors = (/"azure","green","palegreen","yellowgreen","greenyellow" \
            ,"yellow","goldenrod","orange","orangered","red" \
            ,"deeppinK","violet","darkviolet","blueviolet","blue"/)

  res                      = True

  res@gsnMaximize          = True

  res@cnFillOn             = True  
  res@cnLinesOn            = False
  res@cnFillPalette        = colors ;"MPL_GnBu" 
  res@cnLevelSelectionMode  = "ExplicitLevels" 
  res@cnLevels              = (/0.1,10,25,50,75,100,150,200,250,375,500,750,1000,1250,1500/)
  res@cnLevelSpacingF      = 2.           ; NCL chose 4.0
  res@lbOrientation        = "Vertical"

  res@tiMainJust           = "TopCenter"
  res@tiMainString         = "JAS 2005" 

;---Necessary for contours to be overlaid correctly on WRF projection
  res@tfDoNDCOverlay       = True
  res@gsnAddCyclic         = False

;---Set map resources based on projection on WRF output file
  res = wrf_map_resources(b,res)
  ;if (res@mpLeftCornerLonF > mpRightCornerLonF) then
  ;res@mpLeftCornerLonF = res@start_lon - 360.
  res@mpLeftCornerLonF = min(pr@lon2d)
  ;end if
  
  res@mpDataBaseVersion      = "Ncarg4_1"           ; choose more recent database
  res@mpDataSetName          = "Earth..4"               ; high resolution 
  res@mpOutlineBoundarySets  = "AllBoundaries"       ; "National"
  res@mpGeophysicalLineColor = "black"
  res@mpNationalLineColor    = "Black"
  res@mpGeophysicalLineThicknessF = 2.0
  res@mpNationalLineThicknessF = 1.5

;  res@mpMinLatF     = min(pr@lat2d)
;  res@mpMaxLatF     = max(pr@lat2d)
;  res@mpMinLonF     = min(pr@lon2d)
;  res@mpMaxLonF     = max(pr@lon2d)

plot = gsn_csm_contour_map(wks,pr,res)

system("convert -density 150 d01_rain_total.png -format PNG24 -compress LZW -quality 95 -type Optimize -depth 8 -trim +repage d01_rain_total.png")
system("display d01_rain_total.png")
print(wrf_map_resources(b,res))
end
